﻿using System;
using System.Threading.Tasks;
using System.Windows.Controls;
using Loki.Bot;
using Loki.Common;
using log4net;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Windows;
using Exilebuddy;
using LegacyPlugin.Tasks;
using Loki.Game;
using Loki.Game.GameData;
using Loki.Game.Objects;



namespace LegacyPlugin
{
    public class LegacyPlugin : IPlugin
    {
        public static readonly ILog Log = Logger.GetLoggerInstanceForType();
        //private Gui _instance;


        /// <summary> The name of the plugin. </summary>
        public string Name => "LegacyPlugin";

        /// <summary> The description of the plugin. </summary>
        public string Description => "A plugin that helps with legacy shit";

        /// <summary>The author of the plugin.</summary>
        public string Author => "Tormiasz";

        /// <summary>The version of the plugin.</summary>
        public string Version => "1.0.0";

        /// <summary>Initializes this plugin.</summary>
        public void Initialize()
        {
            Log.DebugFormat($"[{Name}] Initialize");
        }

        /// <summary>Deinitializes this object. This is called when the object is being unloaded from the bot.</summary>
        public void Deinitialize()
        {
            Log.DebugFormat($"[{Name}] Deinitialize");
        }

        /// <summary> The plugin start callback. Do any initialization here. </summary>
        public void Start()
        {
            Log.DebugFormat($"[{Name}] Start");

            //If we have AIF enabled then the task name is different
            CommunityLib.Tasks.AddTask(new EquipLeaguestonesTask(), "SortInventoryTask", CommunityLib.Tasks.AddType.After);
            CommunityLib.Tasks.AddTask(new RecoverLeaguestonesTask(), "SortInventoryTask", CommunityLib.Tasks.AddType.After);
        }

        /// <summary> The plugin tick callback. Do any update logic here. </summary>
        public void Tick()
        {
  
        }

        /// <summary> The plugin stop callback. Do any pre-dispose cleanup here. </summary>
        public void Stop()
        {
            Log.DebugFormat($"[{Name}] Stop");
        }

        #region Implementation of ILogic

        /// <summary>
        /// Coroutine logic to execute.
        /// </summary>
        /// <param name="type">The requested type of logic to execute.</param>
        /// <param name="param">Data sent to the object from the caller.</param>
        /// <returns>true if logic was executed to handle this type and false otherwise.</returns>
        public async Task<bool> Logic(string type, params dynamic[] param)
        {

            return false;
        }

        /// <summary>
        /// Non-coroutine logic to execute.
        /// </summary>
        /// <param name="name">The name of the logic to invoke.</param>
        /// <param name="param">The data passed to the logic.</param>
        /// <returns>Data from the executed logic.</returns>
        public object Execute(string name, params dynamic[] param)
        {
            return null;
        }
        
        #endregion

        #region Implementation of IConfigurable

        /// <summary>The settings object. This will be registered in the current configuration.</summary>
        public JsonSettings Settings => null;


        /// <summary> The plugin's settings control. This will be added to the Exilebuddy Settings tab.</summary>
        public UserControl Control => null;

        #endregion

        #region Implementation of IEnableable

        /// <summary> The plugin is being enabled.</summary>
        public void Enable()
        {
            Log.DebugFormat($"[{Name}] Enable");
        }

        /// <summary> The plugin is being disabled.</summary>
        public void Disable()
        {
            Log.DebugFormat($"[{Name}] Disable");
        }
        
        /// <summary>
        /// Is this object currently enabled?
        /// </summary>
        public static bool Enabled { get; set; }

        #endregion

        #region Override of Object

        /// <summary>Returns a string that represents the current object.</summary>
        /// <returns>A string that represents the current object.</returns>
        public override string ToString()
        {
            return Name + ": " + Description;
        }
        #endregion

    }
}
